Bug 1069556 - Review Request: zeromq4 - Software library for fast, message-based applications
Summary: Review Request: zeromq4 - Software library for fast, message-based applications
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Steve Traylen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1045884
TreeView+ depends on / blocked
 
Reported: 2014-02-25 09:43 UTC by Thomas Spura
Modified: 2014-09-22 11:40 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-09-22 11:40:09 UTC
Type: ---
steve.traylen: fedora-review?


Attachments (Terms of Use)

Description Thomas Spura 2014-02-25 09:43:19 UTC
Spec URL: http://tomspur.fedorapeople.org/review/zeromq4.spec
SRPM URL: http://tomspur.fedorapeople.org/review/zeromq4-4.0.3-2.fc20.src.rpm
Description: Software library for fast, message-based applications
Fedora Account System Username: tomspur

$ rpmlint  /home/tomspur/rpmbuild/SRPMS/zeromq4-4.0.3-2.fc20.src.rpm /home/tomspur/rpmbuild/RPMS/x86_64/zeromq4-4.0.3-2.fc20.x86_64.rpm /home/tomspur/rpmbuild/RPMS/x86_64/zeromq4-devel-4.0.3-2.fc20.x86_64.rpm /home/tomspur/rpmbuild/RPMS/x86_64/zeromq4-debuginfo-4.0.3-2.fc20.x86_64.rpm
zeromq4.x86_64: W: no-manual-page-for-binary curve_keygen
4 packages and 0 specfiles checked; 0 errors, 1 warnings.

Comment 1 Robin Lee 2014-03-01 05:21:00 UTC
ZeroMQ API is going stable. Do we really need to keep multiple versions of zeromq?

Comment 2 Thomas Spura 2014-04-02 08:14:45 UTC
Based on previous experience, we decided that the zeromq package contains only the zeromq version 2 and created a version3 package. I'd still like to keep it that way (at least for now). We could still merge it back to the zeromq package later on...

Comment 3 Thomas Spura 2014-04-17 07:30:59 UTC
Changelog:
- update to 4.0.4

Spec URL: http://tomspur.fedorapeople.org/review/zeromq4.spec
SRPM URL: http://tomspur.fedorapeople.org/review/zeromq4-4.0.4-1.fc20.src.rpm

Comment 4 Steve Traylen 2014-09-15 13:00:18 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

- There are some rpmlint warnings below
zeromq4-devel.x86_64: W: only-non-binary-in-usr-lib
zeromq4.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libzmq.so.3.1.0 /lib64/libm.so.6

  Maybe it's worth to investigate and at least comment on these.


Comments:
=========
As mentinoned above it's a little odd how we are packaging renaming from zeromq3 -> 4 here
despite the fact that there is no .so bump here.

Is another option to update the existing  zeromq package to this one and add a compat
package for runtime.

Indeed I think the decision is yours though.






===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
We presume that the exceptions were already approved for the existing
zeromq packages.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v3 or later)", "GPL (v2 or later)", "Unknown or generated". 4
     files have unknown license. 
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages 
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: zeromq4-4.0.4-1.fc20.x86_64.rpm
          zeromq4-devel-4.0.4-1.fc20.x86_64.rpm
          zeromq4-4.0.4-1.fc20.src.rpm
zeromq4.x86_64: W: no-manual-page-for-binary curve_keygen
zeromq4-devel.x86_64: W: only-non-binary-in-usr-lib
3 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint zeromq4-devel zeromq4
zeromq4-devel.x86_64: W: only-non-binary-in-usr-lib
zeromq4.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libzmq.so.3.1.0 /lib64/libm.so.6
zeromq4.x86_64: W: no-manual-page-for-binary curve_keygen
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
zeromq4-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libzmq.so.3()(64bit)
    zeromq4(x86-64)

zeromq4 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpgm-5.2.so.0()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libsodium.so.4()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libzmq.so.3()(64bit)
    rtld(GNU_HASH)



Provides
--------
zeromq4-devel:
    pkgconfig(libzmq)
    zeromq3-devel
    zeromq4-devel
    zeromq4-devel(x86-64)

zeromq4:
    libzmq.so.3()(64bit)
    zeromq3
    zeromq4
    zeromq4(x86-64)



Source checksums
----------------
http://download.zeromq.org/zeromq-4.0.4.tar.gz :
  CHECKSUM(SHA256) this package     : 1ef71d46e94f33e27dd5a1661ed626cd39be4d2d6967792a275040e34457d399
  CHECKSUM(SHA256) upstream package : 1ef71d46e94f33e27dd5a1661ed626cd39be4d2d6967792a275040e34457d399


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1069556
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 5 Jose Pedro Oliveira 2014-09-21 22:12:54 UTC
According to the zeromq4 NEWS file, the library soname will be bumped to 4.0.0 in zeromq 4.0.5.



NEWS file:
https://github.com/zeromq/zeromq4-x/blob/master/NEWS
  
----------

0MQ version 4.0.5 stable, released on 2014/09/xx
================================================
...
* Fixed #994; bump so library number to 4.0.0
...

----------



Zeromq4 issue 994:
https://github.com/zeromq/libzmq/issues/994

Comment 6 Thomas Spura 2014-09-21 22:42:42 UTC
Thanks for the review

(In reply to Steve Traylen from comment #4)
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> Issues:
> =======
> - Package uses either %{buildroot} or $RPM_BUILD_ROOT
>   Note: Using both %{buildroot} and $RPM_BUILD_ROOT
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

Fixed

> - There are some rpmlint warnings below
> zeromq4-devel.x86_64: W: only-non-binary-in-usr-lib

There is only the libzmq.so link inside, which is not "binary", but arch specific and definetely does not belong to /usr/share, as suggested by rpmlint.

> zeromq4.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libzmq.so.3.1.0
> /lib64/libm.so.6
> 
>   Maybe it's worth to investigate and at least comment on these.

I cannot reproduce that here on f20, which is strange as you seem to have used f20 too... I can try to patch the build files to link to libraries as-needed, when I also see that warning on my box.
(Furthermore, I think a needless R on glibc isn't that bad. It should be installed anyway...)

> Comments:
> =========
> As mentinoned above it's a little odd how we are packaging renaming from
> zeromq3 -> 4 here
> despite the fact that there is no .so bump here.
> 
> Is another option to update the existing  zeromq package to this one and add
> a compat
> package for runtime.
> 
> Indeed I think the decision is yours though.

I think this approach is the easiest with the less reviews needed. Once there is a new zeromqX out there, we'll need a new review request and the old ones can serve as the compat packages as needed.
Yet merging back to the original zeromq package would be great to have indeed... :/
Unfortunately, I have not much time to help depending packages to port to newer zeromq's in order to kick version 2 out of Fedora. Any help is appreciated!

Comment 7 Thomas Spura 2014-09-21 22:44:20 UTC
Changelog:
- fix buildroot macros (#1069556)

Spec URL: http://tomspur.fedorapeople.org/review/zeromq4.spec
SRPM URL: http://tomspur.fedorapeople.org/review/zeromq4-4.0.4-2.fc20.src.rpm

Comment 8 Thomas Spura 2014-09-22 11:40:09 UTC
(In reply to Steve Traylen from comment #4)
> Is another option to update the existing  zeromq package to this one and add
> a compat
> package for runtime.
> 
> Indeed I think the decision is yours though.

After further thinking about it, I'll go with this option.

The review request of zeromq2 is at bug #1145100 and once it is done, I'll update to zeromq4 in rawhide and possibly on epel7.

Thanks!


Note You need to log in before you can comment on or make changes to this bug.